<?php

// Can' t be defined outside of smf.
if (!defined('SMF'))
	die ('Hacking attempt...');

//Load topic notes permissions.
function load_topic_note_permissions(&$permissionGroups, &$permissionList)
{
	global $context;

    $permissionList['board']['topic_notes'] = array(true, 'topic', 'moderate');
	$context['non_guest_permissions'][] = 'topic_notes';
}

//Action Jackson right here lol.
function load_topic_note_actions(&$actionsArray)
{
	$actionsArray['addNote'] = array('Subs-TopicNote.php', 'TopicNote');
}

//Add the note button in topics.
function load_topic_note_buttons(&$normal_buttons)
{
	global $context, $scripturl;
	
	$context['can_add_topic_note'] = allowedTo('topic_notes_any') || (allowedTo('topic_notes_own') && $context['user']['started']);
	
	if (!empty($context['can_add_topic_note']))
	{	
	   $normal_buttons['addNote'] = array(
	           'text' => 'add_topic_note', 
			   'lang' => true, 
			   'url' => $scripturl . '?action=addNote;topic=' . $context['current_topic']. ';' . $context['session_var'] . '=' . $context['session_id']);
    }		   
}

//Load our custom language.
function load_topic_note_language()
{
	loadLanguage('TopicNote');
}

//Add note in topics.
function TopicNote()
{
	global $smcFunc, $context, $user_info, $txt;	

	//Load the template.
	loadTemplate('TopicNote');
	
	//Get topic id.
	$topic_id = (int)$_REQUEST['topic'];	

	//Always do the permission check!
	$request = $smcFunc['db_query']('', '
		SELECT id_member_started
		FROM {db_prefix}topics
		WHERE id_topic = {int:topic} 
		LIMIT 1',
		array(
			'topic' => $topic_id,
		)
	);
	list ($starter) = $smcFunc['db_fetch_row']($request);
	$smcFunc['db_free_result']($request);
	
	if (!allowedTo('topic_notes_any') && $user_info['id'] == $starter)
		isAllowedTo('topic_notes_own');
	else
		isAllowedTo('topic_notes_any');
	
	//Check the topic id and make sure that it exists.
	if (!isset($_REQUEST['topic']) || is_array($_REQUEST['topic']))
		fatal_lang_error('topic_doesnt_exist', false);

	//Get the note for this topic.
	$result = $smcFunc['db_query']('', '
		SELECT note
		FROM {db_prefix}topics
		WHERE id_topic = {int:topic}
		LIMIT 1',
		array(
			'topic' => $topic_id,
		)
	);

	//List the note for this topic.
	list ($topicNote) = $smcFunc['db_fetch_row']($result);
	$smcFunc['db_free_result']($result);

	//Adslashes.
	$context['topicNote'] = addslashes($topicNote);

	//Add the new note in this topic.
	if (isset($_POST['saveTopicNote']))
	{
		 //Verify that the form has a "sc" element in it.
		checkSession();

		// This cannot be empty!
		$_POST['note'] = empty($_POST['note']) ? '' : trim($_POST['note']);
		
		if ($_POST['note'] == '')
			fatal_lang_error('note_empty', false);
		
		//Htmlspecialchars for the new note.
		$_POST['note'] = $smcFunc['htmlspecialchars']($_POST['note']);
		
		//Do the actual job.
		$smcFunc['db_query']('', '
			UPDATE {db_prefix}topics
			SET note = {string:note}
			WHERE id_topic = {int:topic}',
			array(
				'note' => $_POST['note'],
				'topic' => $topic_id,
			)
		);

		//Note added successfully. Redirect back to the topic.
		redirectexit('topic=' . $topic_id);
	}
	
	//Log action in the admin log.
	logAction('note_log', array('topic' => $topic_id), $log_type = 'admin');
	
	//Select the topic subject for display at the page title.
	$subject = $smcFunc['db_query']('', '
		SELECT m.subject
		FROM ({db_prefix}messages AS m, {db_prefix}topics AS t)
		WHERE m.id_topic = {int:topic}
			AND t.id_first_msg = m.id_msg
		LIMIT 1',
		array(
			'topic' => $topic_id,
		)
	);

	//List the topic subject.
	list ($topicSubject) = $smcFunc['db_fetch_row']($subject);
	$smcFunc['db_free_result']($subject);
	
	//Register the var for use in template.
	$context['topicSubject'] = $topicSubject;

	//Set the page title.
	$context['page_title'] = $txt['topic_note_title'] . ': ' . $topicSubject . ' ';
}